###############################  COPYRIGHT ##################################
#                                                                           #
#   Copyright (c) 2009-2020 TopLinker Co.,Ltd. (http://www.toplinker.net)   #
#                           ALL RIGHTS RESERVED                             #
#                                                                           #
#   The entire contents of this file is protected by copyright law and      #
#   international treaties. Unauthorized reproduction, reverse-engineering  #
#   and distribution of all or any portion of the code contained in this    #
#   file is strictly prohibited and may result in severe civil and          #
#   criminal penalties and will be prosecuted to the maximum extent         #
#   possible under the law.                                                 #
#                                                                           #
#   RESTRICTIONS                                                            #
#                                                                           #
#   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED              #
#   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE                #
#   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE               #
#   AVAILABLE TO OTHER INDIVIDUALS WITHOUT WRITTEN CONSENT                  #
#   AND PERMISSION FROM DEVELOPER MACHINES                                  #
#                                                                           #
#   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON               #
#   ADDITIONAL RESTRICTIONS.                                                #
#                                                                           #
#############################################################################


#----------------动态库编译设定----------------------------------------------

###设定编译后的动态库名称
TARGET = $$qtLibraryTarget(ecma_twidget)

###添加QT库依赖库
QT       += core  sql script xml network gui widgets

###设定依赖的库列表
LIB_LIST = tbaseutil twidget


#-----------------File List--------------------------------------------

SOURCES += \
    tfiledialog_ecmabinding.cpp \
    tmessagebox_ecmabinding.cpp \
    ttableviewdialog_ecmabinding.cpp \
    twidgetecmaplugin.cpp

HEADERS += \
    tfiledialog_ecmabinding.h \
    tmessagebox_ecmabinding.h \
    ttableviewdialog_ecmabinding.h \
    twidgetecmaplugin.h


#----------------其它编译设定-----------------------

###设定编译成动态库
TEMPLATE = lib

###获取编译平台
TOPIKM_PLATFORM=$$(TOPIKM_PLATFORM)
isEmpty(TOPIKM_PLATFORM){
    TOPIKM_PLATFORM=unknown
    win32 {
        TOPIKM_PLATFORM=win32
        win32-g++ {
            TOPIKM_PLATFORM=win32-mingw
        }
        win32-msvc2013 {
            TOPIKM_PLATFORM=win32-msvc2013
        }
        win32-msvc2015 {
            TOPIKM_PLATFORM=win32-msvc2015
        }
    }
    macx {
        TOPIKM_PLATFORM=macx
    }
    linux {
        TOPIKM_PLATFORM=linux$$QMAKE_HOST.arch
    }
}
###SDK目录
TOPIKM_SDKPATH=$$PWD/../../dist/topikm/qt$$[QT_VERSION]-$${TOPIKM_PLATFORM}

###include头文件Path
INCLUDEPATH += $${TOPIKM_SDKPATH}/include

###支持C++11语法
CONFIG += c++11

###根据不同的系统，Release或Debug版本设定不同的编译目录及动态库后缀
CONFIG += debug_and_release
CONFIG(debug, debug | release) {
    DESTDIR = $${TOPIKM_SDKPATH}/bin_dbg
    win32 {
        DEBUG_SUFFIX = d
    }
    macx {
        DEBUG_SUFFIX = _debug
    }
} else {
    DESTDIR = $${TOPIKM_SDKPATH}/bin
    DEBUG_SUFFIX =
}

###载入需链接的动态库
LIBS += -L$$DESTDIR
for(lib, LIB_LIST) {
    LIBS += -l$${lib}$${DEBUG_SUFFIX}
}

DESTDIR = $${DESTDIR}/script

#版本信息
CONFIG += skip_target_version_ext
VERSION = 6.0.34.0
QMAKE_TARGET_PRODUCT = topikm6-ecma-twidget
QMAKE_TARGET_COMPANY = TopLinker Co.,Ltd.
QMAKE_TARGET_COPYRIGHT = Copyright(C) 2020 TopLinker
