﻿#include "tmessagebox_ecmabinding.h"

#include <tbaseutil/tecmahelper.h>
#include <twidget/tmessagebox.h>

Q_DECLARE_METATYPE(TMessageBox*)
void TMessageBox_EcmaBinding::initBinding(QScriptEngine *iEngine)
{
    iEngine->setDefaultPrototype(qMetaTypeId<TMessageBox*>(), QScriptValue());
    QScriptValue proto = iEngine->newVariant(qVariantFromValue((TMessageBox*)0));
    proto.setPrototype(iEngine->defaultPrototype(qMetaTypeId<TMessageBox*>()));

    TEcmaHelper::registerQObjectMetaType<TMessageBox*>(iEngine);

    QScriptValue ctor = iEngine->newFunction(create, proto);
    ctor.setProperty("msgbox", iEngine->newFunction(msgbox, QScriptValue::SkipInEnumeration));
    ctor.setProperty("info", iEngine->newFunction(info, QScriptValue::SkipInEnumeration));
    ctor.setProperty("ok", iEngine->newFunction(ok, QScriptValue::SkipInEnumeration));
    ctor.setProperty("warning", iEngine->newFunction(warning, QScriptValue::SkipInEnumeration));
    ctor.setProperty("error", iEngine->newFunction(error, QScriptValue::SkipInEnumeration));
    ctor.setProperty("question", iEngine->newFunction(question, QScriptValue::SkipInEnumeration));


    iEngine->globalObject().setProperty("TMessageBox", ctor, QScriptValue::SkipInEnumeration);

}

QScriptValue TMessageBox_EcmaBinding::create(QScriptContext *iContext, QScriptEngine *iEngine)
{
    Q_UNUSED(iEngine);
    if (iContext->thisObject().strictlyEquals(iContext->engine()->globalObject()))
    {
        return TEcmaHelper::throwError_ForgetNew("TMessageBox", iContext);
    }
    if (iContext->argumentCount() == 0)
    {
        return iContext->engine()->newQObject(iContext->thisObject(), new TMessageBox(), QScriptEngine::AutoOwnership);
    }
    else if (iContext->argumentCount() == 1)
    {
        QWidget *parent = qobject_cast<QWidget *>(iContext->argument(0).toQObject());
        return iContext->engine()->newQObject(iContext->thisObject(), new TMessageBox(parent), QScriptEngine::AutoOwnership);
    }
    else
    {
        return TEcmaHelper::throwError_CtorNotFound("TMessageBox", iContext);
    }
}

QScriptValue TMessageBox_EcmaBinding::msgbox(QScriptContext *iContext, QScriptEngine *iEngine)
{
    Q_UNUSED(iEngine);
    int argCountInt = iContext->argumentCount();
    QString resultStr = "";

    if (argCountInt == 0)
    {
        resultStr = TMessageBox::msgbox();
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 1)
    {
        resultStr = TMessageBox::msgbox(qscriptvalue_cast<QWidget *>(iContext->argument(0)));
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 2)
    {
        resultStr = TMessageBox::msgbox(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 3)
    {
        resultStr = TMessageBox::msgbox(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 4)
    {
        resultStr = TMessageBox::msgbox(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 5)
    {
        resultStr = TMessageBox::msgbox(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString(),
                                        iContext->argument(4).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 6)
    {
        resultStr = TMessageBox::msgbox(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString(),
                                        iContext->argument(4).toString(),
                                        iContext->argument(5).toVariant().toStringList());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 7)
    {
        resultStr = TMessageBox::msgbox(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString(),
                                        iContext->argument(4).toString(),
                                        iContext->argument(5).toVariant().toStringList(),
                                        iContext->argument(6).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }


    return TEcmaHelper::throwError_FuncDisMatch("TMessageBox", "msgbox",
                                                "QWidget iParent = 0, " \
                                                "QString iTextStr = '', " \
                                                "QString iDetailStr = '', " \
                                                "QString iIconStr = 'Information', " \
                                                "QString iTitleStr = 'Information', " \
                                                "QStringList iButtonStrLst = ['Ok'], " \
                                                "QString iDefaultBtnStr = ''",
                                                iContext);

}

QScriptValue TMessageBox_EcmaBinding::info(QScriptContext *iContext, QScriptEngine *iEngine)
{
    Q_UNUSED(iEngine);
    int argCountInt = iContext->argumentCount();
    QString resultStr = "";

    if (argCountInt == 0)
    {
        resultStr = TMessageBox::info();
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 1)
    {
        resultStr = TMessageBox::info(qscriptvalue_cast<QWidget *>(iContext->argument(0)));
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 2)
    {
        resultStr = TMessageBox::info(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 3)
    {
        resultStr = TMessageBox::info(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 4)
    {
        resultStr = TMessageBox::info(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 5)
    {
        resultStr = TMessageBox::info(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString(),
                                        iContext->argument(4).toVariant().toStringList());
        return QScriptValue(iContext->engine(), resultStr);
    }

    return TEcmaHelper::throwError_FuncDisMatch("TMessageBox", "info",
                                                "QWidget iParent = 0, " \
                                                "QString iTextStr = '', " \
                                                "QString iDetailStr = '', " \
                                                "QString iTitleStr = '', " \
                                                "QStringList iButtonStrLst = ['Ok'], ",
                                                iContext);
}

QScriptValue TMessageBox_EcmaBinding::ok(QScriptContext *iContext, QScriptEngine *iEngine)
{
    Q_UNUSED(iEngine);
    int argCountInt = iContext->argumentCount();
    QString resultStr = "";

    if (argCountInt == 0)
    {
        resultStr = TMessageBox::ok();
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 1)
    {
        resultStr = TMessageBox::ok(qscriptvalue_cast<QWidget *>(iContext->argument(0)));
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 2)
    {
        resultStr = TMessageBox::ok(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 3)
    {
        resultStr = TMessageBox::ok(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 4)
    {
        resultStr = TMessageBox::ok(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 5)
    {
        resultStr = TMessageBox::ok(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString(),
                                        iContext->argument(4).toVariant().toStringList());
        return QScriptValue(iContext->engine(), resultStr);
    }

    return TEcmaHelper::throwError_FuncDisMatch("TMessageBox", "ok",
                                                "QWidget iParent = 0, " \
                                                "QString iTextStr = '', " \
                                                "QString iDetailStr = '', " \
                                                "QString iTitleStr = '', " \
                                                "QStringList iButtonStrLst = ['Ok'], ",
                                                iContext);
}

QScriptValue TMessageBox_EcmaBinding::warning(QScriptContext *iContext, QScriptEngine *iEngine)
{
    Q_UNUSED(iEngine);
    int argCountInt = iContext->argumentCount();
    QString resultStr = "";

    if (argCountInt == 0)
    {
        resultStr = TMessageBox::warning();
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 1)
    {
        resultStr = TMessageBox::warning(qscriptvalue_cast<QWidget *>(iContext->argument(0)));
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 2)
    {
        resultStr = TMessageBox::warning(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 3)
    {
        resultStr = TMessageBox::warning(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 4)
    {
        resultStr = TMessageBox::warning(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 5)
    {
        resultStr = TMessageBox::warning(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString(),
                                        iContext->argument(4).toVariant().toStringList());
        return QScriptValue(iContext->engine(), resultStr);
    }

    return TEcmaHelper::throwError_FuncDisMatch("TMessageBox", "warning",
                                                "QWidget iParent = 0, " \
                                                "QString iTextStr = '', " \
                                                "QString iDetailStr = '', " \
                                                "QString iTitleStr = '', " \
                                                "QStringList iButtonStrLst = ['Ok'], ",
                                                iContext);
}

QScriptValue TMessageBox_EcmaBinding::error(QScriptContext *iContext, QScriptEngine *iEngine)
{
    Q_UNUSED(iEngine);
    int argCountInt = iContext->argumentCount();
    QString resultStr = "";

    if (argCountInt == 0)
    {
        resultStr = TMessageBox::error();
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 1)
    {
        resultStr = TMessageBox::error(qscriptvalue_cast<QWidget *>(iContext->argument(0)));
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 2)
    {
        resultStr = TMessageBox::error(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 3)
    {
        resultStr = TMessageBox::error(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 4)
    {
        resultStr = TMessageBox::error(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 5)
    {
        resultStr = TMessageBox::error(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString(),
                                        iContext->argument(4).toVariant().toStringList());
        return QScriptValue(iContext->engine(), resultStr);
    }

    return TEcmaHelper::throwError_FuncDisMatch("TMessageBox", "error",
                                                "QWidget iParent = 0, " \
                                                "QString iTextStr = '', " \
                                                "QString iDetailStr = '', " \
                                                "QString iTitleStr = '', " \
                                                "QStringList iButtonStrLst = ['Ok'], ",
                                                iContext);
}

QScriptValue TMessageBox_EcmaBinding::question(QScriptContext *iContext, QScriptEngine *iEngine)
{
    Q_UNUSED(iEngine);
    int argCountInt = iContext->argumentCount();
    QString resultStr = "";

    if (argCountInt == 0)
    {
        resultStr = TMessageBox::question();
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 1)
    {
        resultStr = TMessageBox::question(qscriptvalue_cast<QWidget *>(iContext->argument(0)));
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 2)
    {
        resultStr = TMessageBox::question(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 3)
    {
        resultStr = TMessageBox::question(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 4)
    {
        resultStr = TMessageBox::question(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 5)
    {
        resultStr = TMessageBox::question(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString(),
                                        iContext->argument(4).toVariant().toStringList());
        return QScriptValue(iContext->engine(), resultStr);
    }
    else if (argCountInt == 6)
    {
        resultStr = TMessageBox::question(qscriptvalue_cast<QWidget *>(iContext->argument(0)),
                                        iContext->argument(1).toString(),
                                        iContext->argument(2).toString(),
                                        iContext->argument(3).toString(),
                                        iContext->argument(4).toVariant().toStringList(),
                                        iContext->argument(5).toString());
        return QScriptValue(iContext->engine(), resultStr);
    }

    return TEcmaHelper::throwError_FuncDisMatch("TMessageBox", "error",
                                                "QWidget iParent = 0, " \
                                                "QString iTextStr = '', " \
                                                "QString iDetailStr = '', " \
                                                "QString iTitleStr = '', " \
                                                "QStringList iButtonStrLst = ['Yes','No'], " \
                                                "QString iDefaultBtnStr = ''",
                                                iContext);
}


