#                                                                           #
#   Copyright (c) 2009-2020 TopLinker Co.,Ltd. (http://www.toplinker.net)   #
#                           ALL RIGHTS RESERVED                             #
#                                                                           #
#   The entire contents of this file is protected by copyright law and      #
#   international treaties. Unauthorized reproduction, reverse-engineering  #
#   and distribution of all or any portion of the code contained in this    #
#   file is strictly prohibited and may result in severe civil and          #
#   criminal penalties and will be prosecuted to the maximum extent         #
#   possible under the law.                                                 #
#                                                                           #
#   RESTRICTIONS                                                            #
#                                                                           #
#   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED              #
#   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE                #
#   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE               #
#   AVAILABLE TO OTHER INDIVIDUALS WITHOUT WRITTEN CONSENT                  #
#   AND PERMISSION FROM DEVELOPER MACHINES                                  #
#                                                                           #
#   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON               #
#   ADDITIONAL RESTRICTIONS.                                                #
#                                                                           #
#############################################################################

###设定编译后的动态库名称
TARGET = $$qtLibraryTarget(tmqtt)

###设定编译成动态库
TEMPLATE = lib
DEFINES += TMQTT_LIBRARY

QT       += core network

###设定头文件导出目标Path
HEADER_INSTALL = tmqtt

###设定依赖的库列表
LIB_LIST = qmqtt

SOURCES += \
    witmqttclient.cpp

HEADERS += \
    tmqtt_global.h \
    witmqttclient.h


DIST_DIR = $$PWD/../../dist
include(../shared/shared.pri)

###查看SDK头文件目标路径是否存在，不存在则创建
SDK_HEADER_PATH = $$system_path($${TOPIKM_SDKPATH}/include/$${HEADER_INSTALL})
!exists($${SDK_HEADER_PATH}) {
    mkpath($${SDK_HEADER_PATH})
}

include ($$PWD/../../party3/qmqtt/qmqtt.pri)
INCLUDEPATH += $$PWD/../../party3/qmqtt/include/

###导出header
win32 {
    system(copy *.h $${SDK_HEADER_PATH})
} else {
    system(cp *.h $${SDK_HEADER_PATH})
}

#版本信息
CONFIG += skip_target_version_ext
VERSION = 0.0.1.0
QMAKE_TARGET_PRODUCT = topikm6-mqtt
QMAKE_TARGET_COMPANY = TopLinker Co.,Ltd.
QMAKE_TARGET_COPYRIGHT = Copyright(C) 2020 TopLinker
